package net.shadowfacts.asmr.program

import net.minecraft.util.Identifier
import net.minecraft.util.Language

/**
 * @author shadowfacts
 */
class ProgramBlockInput<Type: Any>(
		val identifier: Identifier,
		val type: ProgramType<Type>,
		val block: ProgramBlock,
		source: ProgramBlockOutput<Type>? = null
) {

	var source: ProgramBlockOutput<Type>? = source
		internal set

	val value: Type?
		get() = source?.value

	fun link(from: ProgramBlockOutput<Type>) {
		from.link(to = this)
	}

	fun unlink() {
		source?.unlink(to = this)
	}

	fun translateName(): String {
		return Language.getInstance().translate("programblock.param.${identifier.namespace}.${identifier.path}")
	}

}
